clc
clear
dt=0;I=0;sr=0;asr=0;dinv=0;por=0;rbl=0;dff=0;x=0;n=1;
% Data for the model - Inventory , Order backlog , cover (in weeks) ,
% Average Time , tabl ( backlog adjustment time) , tai (inventory
% adjustment time) , tmrbl( time for required backlog)
A= [500 800 2 4 4 10 4 0 0];
B=[500 800 2 4 4 3 2 0 0];
C=[400 800 2 4 4 10 4 0 0 ];
D=[400 800 2 4 4 8 5 0 0];
E=[400 800 2 4 4 10 4 10 20];
F=[500 800 2 4 4 10 4 10 20];
disp('Welcome to  Prdoduction distribution model');
disp('This model has 2 parts - Solved Assignments and Policy Runs\n '); % user interface

while(n~=0)
disp('Choose 1-6 for Solved Assignments');
disp('Choose 7-9 for Polcy Runs');
n=input('Choose 0 to exit\n ');     % This shuts the matlab program itself 
if(n==0)
    exit;
end
clc;                    % Clears Screen
if (n==1)
    Input= A;           % array A is fed into the code block    
    disp('You chose Assignment 1');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d\n',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==2)
    Input= B;           % array B is fed into the code block
    disp('You chose Assigment 2');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==3)
    Input= C;           % array C is fed into the code block
    disp('You chose Assigment 3');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==4)
    Input= D;          % array D is fed into the code block
    disp('You chose Assignment 4');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==5)
    Input= E;          % array E is fed into the code block
    disp('You chose Assignment 5');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==6)
    Input= F;          % array F is fed into the code block
    disp('\n\nYou chose Assignment 6');
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7));
end
if (n==7 | n==8 | n==9)
    Input= E;
    fprintf('You chose %d ie Policy Run %d\n', n,n-6);
    fprintf('Initial Invetory= %d\n', Input(1));
    fprintf('Initial Order Backlog=%d\n',Input (2));
    fprintf('Cover = %d\n',Input(4));
    fprintf('Averaging Time= %d',Input(3));
    fprintf('Backlog Adjustment Time=%d\n',Input(5));
    fprintf('Inventory Adjustment Time=%d\n',Input(6));
    fprintf('Time for Require Backlog=%d\n',Input(7))
end

inv(1)=Input(1);
obl(1)=Input(2);
cover=Input(3);
st=Input(4);
tabl=Input(5);
tai=Input(6);
tmrbl=Input(7);
while (dt <= 99.95)               % for running the simulation 2000 times

I = I + 1;
t(I) = dt;

if (dt < Input(8))
sr(I) = 100;
else
sr(I) = 100 + Input(9);
end

if (I == 1)
asr(I) = sr(I);
else
asr(I) = (1 - (0.05 / st)) * asr(I - 1) + (0.05 / st) * sr(I);
end


dinv(I) = asr(I) * cover;
if(n==9)
   por(I) = (dinv(I) - inv(I)) / tai;   %  for policy 3
else
por(I) = asr(I) + (dinv(I) - inv(I)) / tai;  % for  policy 1 and 2
end

rbl(I) = por(I) * tmrbl;

if (n==8)
    dff(I) = (obl(I) - rbl(I)) / tabl;     % Condition for policy 2 
else
dff(I) = (obl(I) - rbl(I)) / tabl;         % Condition for policy 1 
end

if( I < 2000)                              % 2000 is the number of simulation runs choosen arbitarily high
inv(I + 1) = inv(I) + (dff(I) - sr(I)) * 0.05;
obl(I + 1) = obl(I) + (por(I) - dff(I)) * 0.05;
end

dt=dt+0.05;
end

if (tai > tabl)

disp('TAI (Inventory Adjustment Time) > TABL (Backlog Adjustment Time)  The system stabilizes.');

else
    disp('tai < tabl. The system does not stabilize');

end
x=linspace(1,2000,2000);
plot(x,inv,'g',x,obl,'b');            % g - green , b - blue 
xlabel('No. of Cycles ');
ylabel('Units');
legend('Inventory', 'Order BackLog');
end


